!***********************************************************************
!*   
!*   Licensed Materials - Property of IBM.
!*   IBM XL Fortran for Linux, V16.1.0 (5725-C75, 5765-J15)
!*   Copyright IBM Corp. 2003, 2018.
!*   US Government Users Restricted Rights - 
!*   Use, duplication or disclosure restricted by 
!*   GSA ADP Schedule Contract with IBM Corp.
!*
!***********************************************************************


      integer, parameter :: omp_lock_kind              = 8
      integer, parameter :: omp_nest_lock_kind         = 8
      integer, parameter :: omp_proc_bind_kind         = 8
      integer, parameter :: omp_lock_hint_kind         = 8

      integer, parameter :: omp_sched_kind             = 4

      integer(omp_sched_kind), parameter :: omp_sched_static = 1
      integer(omp_sched_kind), parameter :: omp_sched_dynamic = 2
      integer(omp_sched_kind), parameter :: omp_sched_guided = 3
      integer(omp_sched_kind), parameter :: omp_sched_auto = 4

      ! Constants for PROC_BIND
      integer(omp_proc_bind_kind) omp_proc_bind_false
      parameter (omp_proc_bind_false = 0)

      integer(omp_proc_bind_kind) omp_proc_bind_true
      parameter (omp_proc_bind_true = 1)

      integer(omp_proc_bind_kind) omp_proc_bind_master
      parameter (omp_proc_bind_master = 2)

      integer(omp_proc_bind_kind) omp_proc_bind_close
      parameter (omp_proc_bind_close = 3)

      integer(omp_proc_bind_kind) omp_proc_bind_spread
      parameter (omp_proc_bind_spread = 4)

      ! Constants for Lock Hint
      integer(omp_lock_hint_kind) omp_lock_hint_none
      parameter (omp_lock_hint_none = 0)

      integer(omp_lock_hint_kind) omp_lock_hint_uncontended
      parameter (omp_lock_hint_uncontended = 1)

      integer(omp_lock_hint_kind) omp_lock_hint_contended
      parameter (omp_lock_hint_contended = 2)

      integer(omp_lock_hint_kind) omp_lock_hint_nonspeculative
      parameter (omp_lock_hint_nonspeculative = 4)

      integer(omp_lock_hint_kind) omp_lock_hint_speculative
      parameter (omp_lock_hint_speculative = 8)

      ! IBM Extension
      integer(omp_sched_kind), parameter :: ibm_sched_affinity = 1000

      ! OpenMP API V3.1
      integer, parameter :: openmp_version = 201107

      interface
        subroutine omp_destroy_lock(svar)
        import omp_lock_kind
        implicit none
        integer(omp_lock_kind), intent(inout) :: svar
        end subroutine
      end interface

      interface
        subroutine omp_destroy_nest_lock(nvar)
        import omp_nest_lock_kind
        implicit none
        integer(omp_nest_lock_kind), intent(inout) :: nvar
        end subroutine
      end interface

      interface
        function omp_get_dynamic()
        implicit none
        logical :: omp_get_dynamic
        end function
      end interface

      interface
        function omp_get_max_threads()
        implicit none
        integer(4) :: omp_get_max_threads
        end function
      end interface

      interface
        function omp_get_nested()
        implicit none
        logical :: omp_get_nested
        end function
      end interface

      interface
        function omp_get_num_places()
        implicit none
        integer(4) :: omp_get_num_places
        end function
      end interface

      interface omp_get_place_num_procs
        function __xlf_omp_get_place_num_procs_i2(place_num)
        implicit none
        integer(2), intent(in) :: place_num
        integer(2) :: __xlf_omp_get_place_num_procs_i2
        end function

        function __xlf_omp_get_place_num_procs_i4(place_num)
        implicit none
        integer(4), intent(in) :: place_num
        integer(4) :: __xlf_omp_get_place_num_procs_i4
        end function

        function __xlf_omp_get_place_num_procs_i8(place_num)
        implicit none
        integer(8), intent(in) :: place_num
        integer(8) :: __xlf_omp_get_place_num_procs_i8
        end function
      end interface

      interface omp_get_place_proc_ids
        subroutine __xlf_omp_get_place_proc_ids_i2(place_num, ids)
        implicit none
        integer(2), intent(in) :: place_num
        integer(2), intent(inout) :: ids(*)
        end subroutine

        subroutine __xlf_omp_get_place_proc_ids_i4(place_num, ids)
        implicit none
        integer(4), intent(in) :: place_num
        integer(4), intent(inout) :: ids(*)
        end subroutine

        subroutine __xlf_omp_get_place_proc_ids_i8(place_num, ids)
        implicit none
        integer(8), intent(in) :: place_num
        integer(8), intent(inout) :: ids(*)
        end subroutine

      end interface

      interface
        function omp_get_place_num()
        implicit none
        integer(4) :: omp_get_place_num
        end function
      end interface

      interface
        function omp_get_partition_num_places()
        implicit none
        integer(4) :: omp_get_partition_num_places
        end function
      end interface

      interface omp_get_partition_place_nums
        subroutine __xlf_omp_get_partition_place_nums_i2(place_nums)
        implicit none
        integer(2), intent(inout) :: place_nums(*)
        end subroutine

        subroutine __xlf_omp_get_partition_place_nums_i4(place_nums)
        implicit none
        integer(4), intent(inout) :: place_nums(*)
        end subroutine

        subroutine __xlf_omp_get_partition_place_nums_i8(place_nums)
        implicit none
        integer(8), intent(inout) :: place_nums(*)
        end subroutine
      end interface

      interface
        function omp_get_num_procs()
        implicit none
        integer(4) :: omp_get_num_procs
        end function
      end interface

      interface
        function omp_get_num_threads()
        implicit none
        integer(4) :: omp_get_num_threads
        end function
      end interface

      interface
        function omp_get_thread_num()
        implicit none
        integer(4) :: omp_get_thread_num
        end function
      end interface

      interface
        function omp_get_wtick()
        double precision :: omp_get_wtick
        end function
      end interface

      interface
        function omp_get_wtime()
        double precision :: omp_get_wtime
        end function
      end interface

      interface
        subroutine omp_init_lock(svar)
        import omp_lock_kind
        implicit none
        integer(omp_lock_kind), intent(out) :: svar
        end subroutine
      end interface

      interface
        subroutine omp_init_lock_with_hint(svar, hint)
        import omp_lock_kind, omp_lock_hint_kind
        implicit none
        integer(omp_lock_kind), intent(out) :: svar
        integer(omp_lock_hint_kind), intent(in) :: hint
        end subroutine
      end interface

      interface
        subroutine omp_init_nest_lock(nvar)
        import omp_nest_lock_kind
        implicit none
        integer(omp_nest_lock_kind), intent(out) :: nvar
        end subroutine
      end interface

      interface
        subroutine omp_init_nest_lock_with_hint(nvar, hint)
        import omp_nest_lock_kind, omp_lock_hint_kind
        implicit none
        integer(omp_nest_lock_kind), intent(out) :: nvar
        integer(omp_lock_hint_kind), intent(in)  :: hint
        end subroutine
      end interface

      interface
        function omp_in_parallel()
        implicit none
        logical :: omp_in_parallel
        end function
      end interface

      interface
        function omp_in_final()
        implicit none
        logical :: omp_in_final
        end function
      end interface

      interface omp_set_dynamic
        subroutine __xlf_omp_set_dynamic_i2(enable_expr)
        implicit none
        logical(2), intent(in) :: enable_expr
        end subroutine

        subroutine __xlf_omp_set_dynamic_i4(enable_expr)
        implicit none
        logical(4), intent(in) :: enable_expr
        end subroutine

        subroutine __xlf_omp_set_dynamic_i8(enable_expr)
        implicit none
        logical(8), intent(in) :: enable_expr
        end subroutine
      end interface

      interface
        subroutine omp_set_lock(svar)
        import omp_lock_kind
        implicit none
        integer(omp_lock_kind), intent(inout) :: svar
        end subroutine
      end interface

      interface
        subroutine omp_set_nest_lock(nvar)
        import omp_nest_lock_kind
        implicit none
        integer(omp_nest_lock_kind), intent(inout) :: nvar
        end subroutine
      end interface

      interface omp_set_nested
        subroutine __xlf_omp_set_nested_i2(enable_expr)
        implicit none
        logical(2), intent(in) :: enable_expr
        end subroutine

        subroutine __xlf_omp_set_nested_i4(enable_expr)
        implicit none
        logical(4), intent(in) :: enable_expr
        end subroutine

        subroutine __xlf_omp_set_nested_i8(enable_expr)
        implicit none
        logical(8), intent(in) :: enable_expr
        end subroutine
      end interface

      interface omp_set_num_threads
        subroutine __xlf_omp_set_num_threads_i2(number_of_threads_expr)
        implicit none
        integer(2), intent(in) :: number_of_threads_expr
        end subroutine

        subroutine __xlf_omp_set_num_threads_i4(number_of_threads_expr)
        implicit none
        integer(4), intent(in) :: number_of_threads_expr
        end subroutine

        subroutine __xlf_omp_set_num_threads_i8(number_of_threads_expr)
        implicit none
        integer(8), intent(in) :: number_of_threads_expr
        end subroutine
      end interface

      interface
        function omp_test_lock(svar)
        import omp_lock_kind
        implicit none
        logical :: omp_test_lock
        integer(omp_lock_kind), intent(inout) :: svar
        end function
      end interface

      interface
        function omp_test_nest_lock(nvar)
        import omp_nest_lock_kind
        implicit none
        integer(4) :: omp_test_nest_lock
        integer(omp_nest_lock_kind), intent(inout) :: nvar
        end function
      end interface

      interface
        subroutine omp_unset_lock(svar)
        import omp_lock_kind
        implicit none
        integer(omp_lock_kind), intent(inout) :: svar
        end subroutine
      end interface

      interface
        subroutine omp_unset_nest_lock(nvar)
        import omp_nest_lock_kind
        implicit none
        integer(omp_nest_lock_kind), intent(inout) :: nvar
        end subroutine
      end interface

      interface
        function omp_get_thread_limit()
        implicit none
        integer(4) :: omp_get_thread_limit
        end function
      end interface

      interface omp_set_max_active_levels
        subroutine __xlf_omp_set_max_active_levels_i2(max_level_expr)
        implicit none
        integer(2), intent(in) :: max_level_expr
        end subroutine

        subroutine __xlf_omp_set_max_active_levels_i4(max_level_expr)
        implicit none
        integer(4), intent(in) :: max_level_expr
        end subroutine

        subroutine __xlf_omp_set_max_active_levels_i8(max_level_expr)
        implicit none
        integer(8), intent(in) :: max_level_expr
        end subroutine
      end interface

      interface
        function omp_get_max_active_levels()
        implicit none
        integer(4) :: omp_get_max_active_levels
        end function
      end interface

      interface
        function omp_get_level()
        implicit none
        integer(4) :: omp_get_level
        end function
      end interface

      interface omp_get_ancestor_thread_num
        function __xlf_omp_get_ancestor_thread_num_i2(level)
        implicit none
        integer(2), intent(in) :: level
        integer(2) :: __xlf_omp_get_ancestor_thread_num_i2
        end function

        function __xlf_omp_get_ancestor_thread_num_i4(level)
        implicit none
        integer(4), intent(in) :: level
        integer(4) :: __xlf_omp_get_ancestor_thread_num_i4
        end function

        function __xlf_omp_get_ancestor_thread_num_i8(level)
        implicit none
        integer(8), intent(in) :: level
        integer(8) :: __xlf_omp_get_ancestor_thread_num_i8
        end function
      end interface

      interface omp_get_team_size
        function __xlf_omp_get_team_size_i2(level)
        implicit none
        integer(2), intent(in) :: level
        integer(2) :: __xlf_omp_get_team_size_i2
        end function

        function __xlf_omp_get_team_size_i4(level)
        implicit none
        integer(4), intent(in) :: level
        integer(4) :: __xlf_omp_get_team_size_i4
        end function

        function __xlf_omp_get_team_size_i8(level)
        implicit none
        integer(8), intent(in) :: level
        integer(8) :: __xlf_omp_get_team_size_i8
        end function
      end interface

      interface
        function omp_get_active_level()
        implicit none
        integer(4) :: omp_get_active_level
        end function
      end interface

      interface omp_set_schedule
        subroutine __xlf_omp_set_schedule_i2(kind, modifier)
        import omp_sched_kind
        implicit none
        integer(omp_sched_kind), intent(in) :: kind
        integer(2), intent(in) :: modifier
        end subroutine

        subroutine __xlf_omp_set_schedule_i4(kind, modifier)
        import omp_sched_kind
        implicit none
        integer(omp_sched_kind), intent(in) :: kind
        integer(4), intent(in) :: modifier
        end subroutine

        subroutine __xlf_omp_set_schedule_i8(kind, modifier)
        import omp_sched_kind
        implicit none
        integer(omp_sched_kind), intent(in) :: kind
        integer(8), intent(in) :: modifier
        end subroutine
      end interface

      interface omp_get_schedule
        subroutine __xlf_omp_get_schedule_i2(kind, modifier)
        import omp_sched_kind
        implicit none
        integer(omp_sched_kind) :: kind
        integer(2) :: modifier
        end subroutine

        subroutine __xlf_omp_get_schedule_i4(kind, modifier)
        import omp_sched_kind
        implicit none
        integer(omp_sched_kind) :: kind
        integer(4) :: modifier
        end subroutine

        subroutine __xlf_omp_get_schedule_i8(kind, modifier)
        import omp_sched_kind
        implicit none
        integer(omp_sched_kind) :: kind
        integer(8) :: modifier
        end subroutine
      end interface

      interface
        function omp_get_proc_bind()
        import omp_proc_bind_kind
        implicit none
        integer(omp_proc_bind_kind) :: omp_get_proc_bind
        end function
      end interface

      interface
        function  omp_get_num_teams()
        implicit none
        integer(8) :: omp_get_num_teams
        end function
      end interface

      interface
        function  omp_get_team_num()
        implicit none
        integer(8) :: omp_get_team_num
        end function
      end interface

      interface omp_set_default_device
        subroutine __xlf_omp_set_default_device_i2(device_num)
        implicit none
        integer(2), intent(in) :: device_num
        end subroutine

        subroutine __xlf_omp_set_default_device_i4(device_num)
        implicit none
        integer(4), intent(in) :: device_num
        end subroutine

        subroutine __xlf_omp_set_default_device_i8(device_num)
        implicit none
        integer(8), intent(in) :: device_num
        end subroutine
      end interface

      interface
        function omp_get_default_device()
        implicit none
        integer(8) :: omp_get_default_device
        end function
      end interface

      interface
        function omp_get_num_devices()
        implicit none
        integer(8) :: omp_get_num_devices
        end function
      end interface

      interface
        function omp_is_initial_device()
        implicit none
        logical(8) :: omp_is_initial_device
        end function
      end interface

      interface
        function omp_get_initial_device()
        implicit none
        integer(8) :: omp_get_initial_device
        end function
      end interface

      interface
        function omp_get_cancellation()
        implicit none
        logical(8) :: omp_get_cancellation
        end function
      end interface

      interface
        function omp_get_max_task_priority()
        implicit none
        integer(8) :: omp_get_max_task_priority
        end function
      end interface
